/*
 * Dialog with List - Account Details
 * by PhilFlash - http://philflash.inway.fr
 *
 */
 
import mx.containers.Window;
import mx.controls.Button;
import mx.data.components.DataSet;
import mx.controls.List;
import mx.data.to.ValueListIterator;

class CountryForm extends mx.core.View {
	
	var okButton:Button;
	var cancelButton:Button;
	var listVal:List;
	
	// for listVal
	var listdp:Array;
	var initIndex:Number;

	function CountryForm() {
	}
	
	// -----  -----
	public function init():Void {
		super.init();
	}
	
	public function onLoad(obj:Object):Void {
		okButton.addEventListener("click", function(evt:Object) { evt.target._parent.okAction(evt); } );
		cancelButton.addEventListener("click", function(evt:Object) { evt.target._parent.cancelAction(evt); } );
		
		addEventListener("keyDown", this);
		listVal.addEventListener("change", this);
		
		listVal.setDataProvider(listdp);
		listVal.setSelectedIndex((initIndex <0 ? 0 : initIndex));
		// On scrolle  la bonne position
		listVal.vPosition = (initIndex <0 ? 0 : initIndex);
		listVal.dispatchEvent({type:"change"});	
			
		// On donne le focus  la liste
		_parent.focusManager.setFocus(listVal);
	}
	
	// -----  -----
	public function initAsker(dataset:DataSet, currentValue:String):Void {
		// -- Init List --
		listdp = new Array();
		initIndex = -1;
		var dpCursor:ValueListIterator = dataset.getIterator();
		var loop:Number = -1;
		while (dpCursor.hasNext()) {
			dpCursor.next();
			var currentItem = dpCursor.getCurrentItem();
			var labelds = currentItem.label;
			var datads = currentItem.data;

			loop++;
			listdp.addItem({label:labelds, data:datads});
			if (labelds == currentValue) {
				initIndex = loop;
			}
		}
	}
	
	// -----  -----
	public function keyDown(e:Object):Void {
  		if (Key.isDown(Key.ENTER)) {
  			if (okButton.enabled) {
  				okAction();
  			}
  		} 
  		// Ne fonctionne pas !!!!!
  		else if (Key.isDown(Key.ESCAPE)) {
  			cancelAction();
  		}
	}
	
	// -----  -----	
	public function change(evt:Object) {
		var target:Object = evt.target;
		if (target == listVal) {
			changeListAction();
		}
	}
	
	public function changeListAction():Void {
		var selectedIndex = listVal.selectedIndex;
		if (selectedIndex == undefined) {
			okButton.enabled = false;
		} else {
			okButton.enabled = true;		
		}
	}
	
	// ----- Button Action -----
	public function okAction(obj:Object):Void {
		if (this._parent != undefined) {
			var popup = this._parent;
			popup.dispatchEvent({type:"click", detail:1, selectedIndex:listVal.selectedIndex, selectedItem:listVal.selectedItem});
		}	
	}
	
	public function cancelAction(obj:Object):Void {
		if (this._parent != undefined) {
			var popup = this._parent;
			popup.dispatchEvent({type:"click", detail:0});
		}	
	}
}